## ezquake 2.2%2Bgit20150324

=== debian/changelog ===
ezquake (2.2+git20150324-1) unstable; urgency=low

  * Initial release.

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 13 Jul 2016 02:44:00 +0000

## ezquake 2.2+git20150324

=== Makefile ===
### ezQuake Makefile based on Q2PRO ###

-include .config

ifdef CONFIG_WINDOWS
    CPU ?= x86
    SYS ?= Win32
else
    ifndef CPU
        CPU := $(shell uname -m | sed -e s/i.86/i386/ -e s/amd64/x86_64/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/alpha/axp/)
    endif
    ifndef SYS
        SYS := $(shell uname -s)
    endif
endif

ifndef REV
    REV := $(shell ./version.sh --revision)
endif
ifndef VER
    VER := $(shell ./version.sh --version)
endif

LSYS := $(shell echo $(SYS) | tr A-Z a-z)
CC ?= gcc
WINDRES ?= windres
STRIP ?= strip
RM ?= rm -f
RMDIR ?= rm -rf
MKDIR ?= mkdir -p

CFLAGS ?= -O2 -Wall -Wno-pointer-to-int-cast -Wno-int-to-pointer-cast -Wno-strict-aliasing -g -MMD $(INCLUDES)
RCFLAGS ?=
LDFLAGS ?=
LIBS ?=

CFLAGS_c :=
RCFLAGS_c :=
LDFLAGS_c :=

ifdef CONFIG_WINDOWS
    LDFLAGS_c += -mwindows

    # Mark images as DEP and ASLR compatible on x86 Windows
    ifeq ($(CPU),x86)
        LDFLAGS_c += -Wl,--nxcompat,--dynamicbase
    endif
else
    # Hide ELF symbols by default
    CFLAGS_c += -fvisibility=hidden

    # Resolve all symbols at link time
    ifeq ($(SYS),Linux)
        LDFLAGS_c += -Wl,--no-undefined
    endif

	# Make sure we can relink dynamic libraries
	ifeq ($(SYS),Darwin)
		LDFLAGS_c += -headerpad_max_install_names

		# Also on OS X 10.10 at least, expat is a system library
		EXPAT_CFLAGS =
		EXPAT_LIBS = -lexpat
	endif
endif

BUILD_DEFS := -DCPUSTRING='"$(CPU)"'
BUILD_DEFS += -DBUILDSTRING='"$(SYS)"'

VER_DEFS := -DREVISION=$(REV)
VER_DEFS += -DVERSION='"$(VER)"'

SDL2_CFLAGS ?= $(shell sdl2-config --cflags)
SDL2_LIBS ?= $(shell sdl2-config --libs)

CFLAGS_c += $(BUILD_DEFS) $(VER_DEFS) $(PATH_DEFS) $(SDL2_CFLAGS) -DJSS_CAM -DUSE_PR2 -DWITH_NQPROGS -DUSE_SDL2 -DWITH_ZIP
LIBS_c += $(SDL2_LIBS)

# built-in requirements
ZLIB_CFLAGS ?= -DWITH_ZLIB
ZLIB_LIBS ?= -lz
CFLAGS_c += $(ZLIB_CFLAGS)
LIBS_c += $(ZLIB_LIBS)

PCRE_CFLAGS ?= $(shell pkg-config libpcre --cflags)
PCRE_LIBS ?= $(shell pkg-config libpcre --libs)
CFLAGS_c += $(PCRE_CFLAGS)
LIBS_c += $(PCRE_LIBS)

EXPAT_CFLAGS ?= $(shell pkg-config expat --cflags)
EXPAT_LIBS ?= $(shell pkg-config expat --libs)
CFLAGS_c += $(EXPAT_CFLAGS)
LIBS_c += $(EXPAT_LIBS)

PNG_CFLAGS ?= $(shell pkg-config libpng --cflags) -DWITH_PNG -D__Q_PNG14__
PNG_LIBS ?= $(shell pkg-config libpng --libs)
CFLAGS_c += $(PNG_CFLAGS)
LIBS_c += $(PNG_LIBS)

CURL_CFLAGS ?= $(shell pkg-config libcurl --cflags)
CURL_LIBS ?= $(shell pkg-config libcurl --libs)
CFLAGS_c += $(CURL_CFLAGS)
LIBS_c += $(CURL_LIBS)

JANSSON_CFLAGS ?= $(shell pkg-config jansson --cflags)
JANSSON_LIBS ?= $(shell pkg-config jansson --libs)
CFLAGS += $(JANSSON_CFLAGS)
LIBS_c += $(JANSSON_LIBS)

# windres needs special quoting...
RCFLAGS_c += -DREVISION=$(REV) -DVERSION='\"$(VER)\"'

### Object Files ###

COMMON_OBJS := \
    cmodel.o		\
    cmd.o		\
    com_msg.o		\
    common.o		\
    crc.o		\
    cvar.o		\
    fs.o		\
    vfs_os.o		\
    vfs_pak.o		\
    vfs_zip.o		\
    vfs_tcp.o		\
    vfs_gzip.o		\
    vfs_doomwad.o	\
    vfs_mmap.o		\
    vfs_tar.o		\
    hash.o		\
    host.o		\
    mathlib.o		\
    md4.o		\
    net.o		\
    net_chan.o		\
    q_shared.o		\
    version.o		\
    zone.o

# temporary
SERVER_OBJS := \
    pmove.o \
    pmovetst.o \
    pr_cmds.o \
    pr_edict.o \
    pr_exec.o \
    pr2_cmds.o \
    pr2_edict.o \
    pr2_exec.o \
    pr2_vm.o \
    sv_ccmds.o \
    sv_ents.o \
    sv_init.o \
    sv_main.o \
    sv_master.o \
    sv_move.o \
    sv_nchan.o \
    sv_phys.o \
    sv_save.o \
    sv_send.o \
    sv_user.o \
    sv_world.o \
    sv_demo.o \
    sv_demo_misc.o \
    sv_demo_qtv.o \
    sv_login.o \
    sv_mod_frags.o

OBJS_c := \
    $(COMMON_OBJS) \
    $(SERVER_OBJS) \
    ioapi.o \
    unzip.o \
    Ctrl.o \
    Ctrl_EditBox.o \
    Ctrl_PageViewer.o \
    Ctrl_ScrollBar.o \
    Ctrl_Tab.o \
    EX_FileList.o \
    EX_browser.o \
    EX_browser_net.o \
    EX_browser_pathfind.o \
    EX_browser_ping.o \
    EX_browser_qtvlist.o \
    EX_browser_sources.o \
    EX_qtvlist.o \
    ez_controls.o \
    ez_scrollbar.o \
    ez_scrollpane.o \
    ez_label.o \
    ez_slider.o \
    ez_button.o \
    ez_window.o \
    cl_cam.o \
    cl_cmd.o \
    cl_demo.o \
    cl_nqdemo.o \
    cl_ents.o \
    cl_input.o \
    cl_main.o \
    cl_parse.o \
    cl_pred.o \
    cl_screen.o \
    cl_slist.o \
    cl_tcl.o \
    cl_tent.o \
    cl_view.o \
    common_draw.o \
    console.o \
    config_manager.o \
    demo_controls.o \
    document_rendering.o \
    fchecks.o \
    fmod.o \
    fragstats.o \
    help.o \
    help_files.o \
    hud.o \
    hud_common.o \
    hud_editor.o \
    ignore.o \
    image.o \
    irc_filter.o \
    irc.o \
    keys.o \
    logging.o \
    match_tools.o \
    menu.o \
    menu_demo.o \
    menu_ingame.o \
    menu_mp3player.o \
    menu_multiplayer.o \
    menu_options.o \
    menu_proxy.o \
    modules.o \
    movie.o \
    mp3_player.o \
    mp3_audacious.o \
    mp3_xmms.o \
    mp3_xmms2.o \
    mp3_mpd.o \
    mp3_winamp.o \
    mvd_autotrack.o \
    mvd_utils.o \
    mvd_xmlstats.o \
    parser.o \
    qtv.o \
    r_part.o \
    rulesets.o \
    sbar.o \
    settings_page.o \
    sha1.o \
    skin.o \
    snd_dma.o \
    snd_mem.o \
    snd_mix.o \
    snd_ov.o \
    stats_grid.o \
    teamplay.o \
    tp_msgs.o \
    tp_triggers.o \
    textencoding.o \
    utils.o \
    vx_tracker.o \
    wad.o \
    xsd.o \
    xsd_command.o \
    xsd_document.o \
    xsd_variable.o \
    collision.o \
    gl_draw.o \
    gl_bloom.o \
    gl_md3.o \
    gl_mesh.o \
    gl_model.o \
    gl_ngraph.o \
    gl_refrag.o \
    gl_rlight.o \
    gl_rmain.o \
    gl_rmisc.o \
    gl_rpart.o \
    gl_rsurf.o \
    gl_texture.o \
    gl_warp.o \
    vx_camera.o \
    vx_coronas.o \
    vx_motiontrail.o \
    vx_stuff.o \
    vx_vertexlights.o \
    vid_common_gl.o \
    cd_null.o \
    vid_sdl2.o \
    snd_sdl2.o \
    sys_sdl2.o \
    in_sdl2.o

### Configuration Options ###

ifdef CONFIG_WINDOWS
    OBJS_c += \
	movie_avi.o \
	localtime_win.o \
	sys_win.o \
	winquake.o
    LIBS_c += -lopengl32 -lws2_32 -lwinmm
else
    OBJS_c += \
    	localtime_posix.o \
	sys_posix.o \
    	linux_signals.o

    LIBS_c += -lm

    ifeq ($(SYS),Darwin)
        LIBS_c += -framework OpenGL -framework IOKit -framework CoreServices -ldl
	OBJS_c += in_osx.o
    else
        LIBS_c += -lGL
    endif

    ifneq ($(SYS),FreeBSD)
        LIBS_c += -ldl
    endif
endif

ifdef CONFIG_OGG
    OGG_CFLAGS ?= $(shell pkg-config vorbisfile --cflags) -DWITH_OGG_VORBIS
    OGG_LIBS ?= $(shell pkg-config vorbisfile --libs)
    CFLAGS_c += $(OGG_CFLAGS)
    LIBS_c += $(OGG_LIBS)
endif

ifdef CONFIG_JPEG
    JPEG_CFLAGS ?= -DWITH_JPEG
    JPEG_LIBS ?= -ljpeg
    CFLAGS_c += $(JPEG_CFLAGS)
    LIBS_c += $(JPEG_LIBS)
endif

### Targets ###

ifdef CONFIG_WINDOWS
    TARG_c := ezquake.exe
else
    TARG_c := ezquake-$(LSYS)-$(CPU)
endif

all: $(TARG_c)

default: all

.PHONY: all default clean strip

# Define V=1 to show command line.
ifdef V
    Q :=
    E := @true
else
    Q := @
    E := @echo
endif

# Temporary build directories
BUILD_c := .ezquake

# Rewrite paths to build directories
OBJS_c := $(patsubst %,$(BUILD_c)/%,$(OBJS_c))

DEPS_c := $(OBJS_c:.o=.d)

-include $(DEPS_c)

clean:
	$(E) [CLEAN]
	$(Q)$(RM) $(TARG_c)
	$(Q)$(RMDIR) $(BUILD_c)

strip: $(TARG_c)
	$(E) [STRIP]
	$(Q)$(STRIP) $(TARG_c)

# ------

$(BUILD_c)/%.o: %.c
	$(E) [CC] $@
	$(Q)$(MKDIR) $(@D)
	$(Q)$(CC) -c $(CFLAGS) $(CFLAGS_c) -o $@ $<

$(BUILD_c)/%.o: %.rc
	$(E) [RC] $@
	$(Q)$(MKDIR) $(@D)
	$(Q)$(WINDRES) $(RCFLAGS) $(RCFLAGS_c) -o $@ $<

$(TARG_c): $(OBJS_c)
	$(E) [LD] $@
	$(Q)$(MKDIR) $(@D)
	$(Q)$(CC) $(LDFLAGS) $(LDFLAGS_c) -o $@ $(OBJS_c) $(LIBS) $(LIBS_c)

=== debian/control ===
Source: ezquake
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Michael Gilbert <mgilbert@debian.org>
Build-Depends:
 debhelper (>= 9),
 zlib1g-dev,
 libpng-dev,
 libsdl2-dev,
 libjpeg-dev,
 liblzma-dev,
 libpcre3-dev,
 libexpat-dev,
 libvorbis-dev,
 libjansson-dev,
 libcurl4-gnutls-dev,
Standards-Version: 3.9.6
Homepage: http://ezquake.sourceforge.net
Vcs-Git: git://anonscm.debian.org/pkg-games/ezquake.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/ezquake.git

Package: ezquake
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 quake-data | game-data-packager,
Provides:
 quake-engine,
Description: modern QuakeWorld client
 ezQuake is a modern QuakeWorld engine.  It adds many useful features like
 modern graphics, QuakeTV support, mp3 playback, multi-monitor support, a
 built-in server browser, and many features serving the needs of
 competitive Quake gamers.
 .
 QuakeWorld itelf is a variant of the Quake engine designed specifically
 for online gameplay.
 .
 This package contains no data files. To use it, you will need either the
 commercial Quake 1 data, the shareware data (game-data-packager can be
 helpful), or free game data files such as OpenQuartz.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export MAKEFLAGS=V=1

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)

export DEB_LDFLAGS_MAINT_APPEND=-pthread

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel

## ezquake 3.2.3

=== debian/changelog ===
ezquake (3.2.3-1) unstable; urgency=medium

  * New upstream release.
    - Limits cl_rollangle to 5 in competitive rulesets.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 16 Feb 2021 23:08:07 +0000

ezquake (3.2.2-3) unstable; urgency=medium

  * Remove MP3 support from the package description (closes: #981727).

 -- Michael Gilbert <mgilbert@debian.org>  Mon, 08 Feb 2021 01:45:13 +0000

ezquake (3.2.2-2) unstable; urgency=medium

  * Add minizip to the build dependencies.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 26 Jan 2021 04:58:14 +0000

ezquake (3.2.2-1) unstable; urgency=medium

  * New upstream release (closes: #973940).
    - Support for building with gcc 10 (closes: #957187).
  * Remove teamplay.cfg from the upstream tarball (closes: #884085).
  * Update to debhelper 11.
  * Add an upstream watch file.
  * Build using meson and ninja.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 26 Jan 2021 04:30:50 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,9 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 11),
+ meson,
+ ninja-build,
  zlib1g-dev,
  libpng-dev,
  libsdl2-dev,
@@ -14,6 +16,8 @@
  libexpat-dev,
  libvorbis-dev,
  libjansson-dev,
+ libminizip-dev,
+ libspeexdsp-dev,
  libcurl4-gnutls-dev,
 Standards-Version: 3.9.6
 Homepage: http://ezquake.sourceforge.net
@@ -25,15 +29,14 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Suggests:
+Recommends:
  quake-data | game-data-packager,
 Provides:
  quake-engine,
 Description: modern QuakeWorld client
  ezQuake is a modern QuakeWorld engine.  It adds many useful features like
- modern graphics, QuakeTV support, mp3 playback, multi-monitor support, a
- built-in server browser, and many features serving the needs of
- competitive Quake gamers.
+ modern graphics, QuakeTV support, multi-monitor support, a built-in server
+ browser, and many features serving the nedes of competitive Quake gamers.
  .
  QuakeWorld itelf is a variant of the Quake engine designed specifically
  for online gameplay.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel

override_dh_auto_install-arch:
	cp obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)/ezquake ezquake
	dh_auto_install

override_dh_clean:
	rm -rf opengl minizip vstudio-libs mingw32-libs misc/vstudio misc/install
	dh_clean

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/ezQuake/ezquake-source/tags .*/v?(\d\S+)\.tar\.gz

## ezquake 3.6.1

=== debian/changelog ===
ezquake (3.6.1-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Minimal invasive RC bug fix NMU as maintainer isn't reachable
  * Make compile warnings non-fatal (Closes: #1030184)
  * Fix duplicate file globs in debian/copyright

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 02 Feb 2023 13:18:24 +0100

ezquake (3.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Fix compiler warnings.
  * Update to debhelper 13.
  * Update debian/copyright.
  * Update standards version to 4.6.2.

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 22 Jan 2023 20:25:58 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 13),
  meson,
  ninja-build,
  zlib1g-dev,
@@ -14,15 +14,16 @@
  liblzma-dev,
  libpcre3-dev,
  libexpat-dev,
+ libspeex-dev,
  libvorbis-dev,
  libjansson-dev,
  libminizip-dev,
+ libsndfile1-dev,
  libspeexdsp-dev,
  libcurl4-gnutls-dev,
-Standards-Version: 3.9.6
-Homepage: http://ezquake.sourceforge.net
-Vcs-Git: git://anonscm.debian.org/pkg-games/ezquake.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/ezquake.git
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: http://ezquake.com
 
 Package: ezquake
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,12 +2,14 @@
 
 export DH_VERBOSE=1
 
-export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
+export DEB_BUILD_DATE="$(shell dpkg-parsechangelog --show-field=date)"
+
+export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS) -Wno-deprecated-declarations -Wno-misleading-indentation -Wno-format-truncation -Wno-unused-function -DBUILD_DATE=\"$(DEB_BUILD_DATE)\"
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_install-arch:
 	cp obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)/ezquake ezquake

## ezquake 3.6.4

=== Makefile ===
### ezQuake Makefile based on Q2PRO ###

ifdef EZ_CONFIG_FILE
    -include $(EZ_CONFIG_FILE)
else
    -include .config
endif

ifdef CONFIG_WINDOWS
    CPU ?= x86
    SYS ?= Win32
else
    ifndef CPU
        CPU := $(shell uname -m | sed -e s/i.86/i386/ -e s/amd64/x86_64/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/alpha/axp/)
    endif
    ifndef SYS
        SYS := $(shell uname -s)
    endif
endif

ifndef REV
    REV := $(shell ./version.sh --revision)
endif
ifndef VER
    VER := $(shell ./version.sh --version)
endif

LSYS := $(shell echo $(SYS) | tr A-Z a-z)
CC ?= gcc
WINDRES ?= windres
STRIP ?= strip
RM ?= rm -f
RMDIR ?= rm -rf
MKDIR ?= mkdir -p
JSON2C ?= ./json2c.sh

CFLAGS ?= -O2 -Wall -Wno-pointer-to-int-cast -Wno-int-to-pointer-cast -Wno-strict-aliasing -Werror=strict-prototypes -Werror=old-style-definition -g -MMD $(INCLUDES)
RCFLAGS ?=
LDFLAGS ?=
LIBS ?=

CFLAGS_c :=
RCFLAGS_c :=
LDFLAGS_c :=

SRC_DIR = src

ifneq (,$(wildcard $(SRC_DIR)/qwprot/src/*.h))
    INCLUDES = -I$(SRC_DIR)/qwprot/src
else
    $(error qwprot submodule missing, try initializing submodules with "git submodule update --init --recursive --remote")
endif

ifdef CONFIG_WINDOWS
    LDFLAGS_c += -mwindows

    # Mark images as DEP and ASLR compatible on x86 Windows
    ifeq ($(CPU),x86)
        LDFLAGS_c += -Wl,--nxcompat,--dynamicbase
    endif
else
    # Hide ELF symbols by default
    CFLAGS_c += -fvisibility=hidden

    # Resolve all symbols at link time
    ifeq ($(SYS),Linux)
    	CFLAGS += -DX11_GAMMA_WORKAROUND
        LDFLAGS_c += -Wl,--no-undefined
    endif

    ifeq ($(SYS),Darwin)
        # 10.11 El Capitan does not search for header files here by default
        CFLAGS_c += -I/usr/local/include

        # For re-link/deploy dynamic libraries
        LDFLAGS_c += -headerpad_max_install_names

        # Cross-compiling support
        ifneq ($(DARWIN_TARGET),)
            CFLAGS_c += -target $(DARWIN_TARGET)
            LDFLAGS_c += -target $(DARWIN_TARGET)
        else
            CFLAGS_c += -mmacosx-version-min=10.8
            LDFLAGS_c += -mmacosx-version-min=10.8
        endif

        # From  10.10 at least, expat is a system library
        EXPAT_CFLAGS =
        EXPAT_LIBS = -lexpat

        CURL_CFLAGS =
        CURL_LIBS = -lcurl
    endif
endif

BUILD_DEFS := -DCPUSTRING='"$(CPU)"'
BUILD_DEFS += -DBUILDSTRING='"$(SYS)"'

VER_DEFS := -DREVISION=$(REV)
VER_DEFS += -DVERSION='"$(VER)"'

SDL2_CFLAGS ?= $(shell sdl2-config --cflags)
SDL2_LIBS ?= $(shell sdl2-config --libs)

ifdef TRAVIS_BUILD
    BUILD_DEFS += -DTRAVIS_BUILD
endif

CFLAGS_c += $(BUILD_DEFS) $(VER_DEFS) $(PATH_DEFS) $(SDL2_CFLAGS) -DNDEBUG -DJSS_CAM -DUSE_PR2 -DWITH_NQPROGS -DUSE_SDL2 -DWITH_ZIP
LIBS_c += $(SDL2_LIBS)

# built-in requirements
ZLIB_CFLAGS ?= -DWITH_ZLIB
ZLIB_LIBS ?= -lz
CFLAGS_c += $(ZLIB_CFLAGS)
LIBS_c += $(ZLIB_LIBS)

PCRE2_CFLAGS ?= $(shell pkg-config libpcre2-8 --cflags)
PCRE2_LIBS ?= $(shell pkg-config libpcre2-8 --libs)
CFLAGS_c += $(PCRE2_CFLAGS) -DPCRE2_CODE_UNIT_WIDTH=8
LIBS_c += $(PCRE2_LIBS)

EXPAT_CFLAGS ?= $(shell pkg-config expat --cflags)
EXPAT_LIBS ?= $(shell pkg-config expat --libs)
CFLAGS_c += $(EXPAT_CFLAGS)
LIBS_c += $(EXPAT_LIBS)

PNG_CFLAGS ?= $(shell pkg-config libpng --cflags) -DWITH_PNG
PNG_LIBS ?= $(shell pkg-config libpng --libs)
CFLAGS_c += $(PNG_CFLAGS)
LIBS_c += $(PNG_LIBS)

JPEG_CFLAGS ?= $(shell pkg-config libjpeg --cflags) -DWITH_JPEG
JPEG_LIBS ?= $(shell pkg-config libjpeg --libs)
CFLAGS_c += $(JPEG_CFLAGS)
LIBS_c += $(JPEG_LIBS)

CURL_CFLAGS ?= $(shell pkg-config libcurl --cflags)
CURL_LIBS ?= $(shell pkg-config libcurl --libs)
CFLAGS_c += $(CURL_CFLAGS)
LIBS_c += $(CURL_LIBS)

JANSSON_CFLAGS ?= $(shell pkg-config jansson --cflags)
JANSSON_LIBS ?= $(shell pkg-config jansson --libs)
CFLAGS += $(JANSSON_CFLAGS)
LIBS_c += $(JANSSON_LIBS)

MINIZIP_CFLAGS ?= $(shell pkg-config --cflags minizip)
MINIZIP_LIBS ?= $(shell pkg-config --libs minizip)
CFLAGS_c += $(MINIZIP_CFLAGS)
LIBS_c += $(MINIZIP_LIBS)

SPEEX_LIBS ?= $(shell pkg-config speex --libs) $(shell pkg-config speexdsp --libs)
ifdef SPEEX_LIBS
    CFLAGS_c += $(shell pkg-config speex --cflags) $(shell pkg-config speexdsp --cflags) -DWITH_SPEEX
endif
LIBS_c += $(SPEEX_LIBS)

ifndef CONFIG_WINDOWS
    ifeq ($(shell pkg-config --exists freetype2 && echo 1),1)
        FREETYPE_CFLAGS ?= $(shell pkg-config freetype2 --cflags)
        FREETYPE_LIBS ?= $(shell pkg-config freetype2 --libs)
    endif

    ifdef FREETYPE_LIBS
        CFLAGS_c += -DEZ_FREETYPE_SUPPORT_STATIC
    endif
endif

ifdef FREETYPE_LIBS
    CFLAGS_c += -DEZ_FREETYPE_SUPPORT
    LIBS_c += $(FREETYPE_LIBS)
    CFLAGS += $(FREETYPE_CFLAGS)
endif

ifdef OLD_WAV_LOADING
    CFLAGS_c += -DOLD_WAV_LOADING
else
    SNDFILE_CFLAGS ?= $(shell pkg-config sndfile --cflags)
    SNDFILE_LIBS ?= $(shell pkg-config sndfile --libs)
    CFLAGS += $(SNDFILE_CFLAGS)
    LIBS_c += $(SNDFILE_LIBS)
endif

# windres needs special quoting...
RCFLAGS_c += -DREVISION=$(REV) -DVERSION='\"$(VER)\"'

### Object Files ###

COMMON_OBJS := \
    $(SRC_DIR)/cmodel.o           \
    $(SRC_DIR)/cmd.o              \
    $(SRC_DIR)/com_msg.o          \
    $(SRC_DIR)/common.o           \
    $(SRC_DIR)/crc.o              \
    $(SRC_DIR)/cvar.o             \
    $(SRC_DIR)/fs.o               \
    $(SRC_DIR)/vfs_os.o           \
    $(SRC_DIR)/vfs_pak.o          \
    $(SRC_DIR)/vfs_zip.o          \
    $(SRC_DIR)/vfs_tcp.o          \
    $(SRC_DIR)/vfs_gzip.o         \
    $(SRC_DIR)/vfs_doomwad.o      \
    $(SRC_DIR)/vfs_mmap.o         \
    $(SRC_DIR)/vfs_tar.o          \
    $(SRC_DIR)/hash.o             \
    $(SRC_DIR)/host.o             \
    $(SRC_DIR)/mathlib.o          \
    $(SRC_DIR)/md4.o              \
    $(SRC_DIR)/sha3.o             \
    $(SRC_DIR)/net.o              \
    $(SRC_DIR)/net_chan.o         \
    $(SRC_DIR)/q_shared.o         \
    $(SRC_DIR)/version.o          \
    $(SRC_DIR)/zone.o             \
    $(SRC_DIR)/pmove.o            \
    $(SRC_DIR)/pmovetst.o

SERVER_OBJS := \
    $(SRC_DIR)/pr_cmds.o \
    $(SRC_DIR)/pr_edict.o \
    $(SRC_DIR)/pr_exec.o \
    $(SRC_DIR)/pr2_cmds.o \
    $(SRC_DIR)/pr2_edict.o \
    $(SRC_DIR)/pr2_exec.o \
    $(SRC_DIR)/pr2_vm.o \
    $(SRC_DIR)/sv_ccmds.o \
    $(SRC_DIR)/sv_ents.o \
    $(SRC_DIR)/sv_init.o \
    $(SRC_DIR)/sv_main.o \
    $(SRC_DIR)/sv_master.o \
    $(SRC_DIR)/sv_move.o \
    $(SRC_DIR)/sv_nchan.o \
    $(SRC_DIR)/sv_phys.o \
    $(SRC_DIR)/sv_save.o \
    $(SRC_DIR)/sv_send.o \
    $(SRC_DIR)/sv_user.o \
    $(SRC_DIR)/sv_world.o \
    $(SRC_DIR)/sv_demo.o \
    $(SRC_DIR)/sv_demo_misc.o \
    $(SRC_DIR)/sv_demo_qtv.o \
    $(SRC_DIR)/sv_login.o \
    $(SRC_DIR)/sv_mod_frags.o

HELP_OBJS := \
    $(patsubst help_%.json,help_%.o,$(wildcard help_*.json))

MODERN_GLSL_OBJS := \
    $(patsubst $(SRC_DIR)/glsl/%.glsl,$(SRC_DIR)/glsl_%.glsl.o,$(wildcard $(SRC_DIR)/glsl/*.glsl))

CLASSIC_GLSL_OBJS := \
    $(patsubst $(SRC_DIR)/glsl/glc/%.glsl,$(SRC_DIR)/glsl_%.glsl.o,$(wildcard $(SRC_DIR)/glsl/glc/*.glsl))

MODERN_OPENGL_OBJS := \
    $(MODERN_GLSL_OBJS) \
    $(SRC_DIR)/glm_aliasmodel.o \
    $(SRC_DIR)/glm_brushmodel.o \
    $(SRC_DIR)/glm_draw.o \
    $(SRC_DIR)/glm_framebuffer.o \
    $(SRC_DIR)/glm_lightmaps.o \
    $(SRC_DIR)/glm_md3.o \
    $(SRC_DIR)/glm_misc.o \
    $(SRC_DIR)/glm_particles.o \
    $(SRC_DIR)/glm_performance.o \
    $(SRC_DIR)/glm_main.o \
    $(SRC_DIR)/glm_rmain.o \
    $(SRC_DIR)/glm_rsurf.o \
    $(SRC_DIR)/glm_sdl.o \
    $(SRC_DIR)/glm_sprite.o \
    $(SRC_DIR)/glm_sprite3d.o \
    $(SRC_DIR)/glm_state.o \
    $(SRC_DIR)/glm_texture_arrays.o \
    $(SRC_DIR)/glm_vao.o

CLASSIC_OPENGL_OBJS := \
    $(CLASSIC_GLSL_OBJS) \
    $(SRC_DIR)/glc_aliasmodel.o \
    $(SRC_DIR)/glc_aliasmodel_mesh.o \
    $(SRC_DIR)/glc_bloom.o \
    $(SRC_DIR)/glc_brushmodel.o \
    $(SRC_DIR)/glc_draw.o \
    $(SRC_DIR)/glc_framebuffer.o \
    $(SRC_DIR)/glc_lightmaps.o \
    $(SRC_DIR)/glc_main.o \
    $(SRC_DIR)/glc_matrix.o \
    $(SRC_DIR)/glc_md3.o \
    $(SRC_DIR)/glc_misc.o \
    $(SRC_DIR)/glc_particles.o \
    $(SRC_DIR)/glc_performance.o \
    $(SRC_DIR)/glc_sdl.o \
    $(SRC_DIR)/glc_sky.o \
    $(SRC_DIR)/glc_sprite3d.o \
    $(SRC_DIR)/glc_state.o \
    $(SRC_DIR)/glc_surf.o \
    $(SRC_DIR)/glc_turb_surface.o \
    $(SRC_DIR)/glc_vao.o \
    $(SRC_DIR)/glc_warp.o

COMMON_OPENGL_OBJS := \
    $(SRC_DIR)/gl_aliasmodel.o \
    $(SRC_DIR)/gl_aliasmodel_md3.o \
    $(SRC_DIR)/gl_buffers.o \
    $(SRC_DIR)/gl_debug.o \
    $(SRC_DIR)/gl_drawcall_wrappers.o \
    $(SRC_DIR)/gl_framebuffer.o \
    $(SRC_DIR)/gl_misc.o \
    $(SRC_DIR)/gl_program.o \
    $(SRC_DIR)/gl_sdl.o \
    $(SRC_DIR)/gl_sprite3d.o \
    $(SRC_DIR)/gl_state.o \
    $(SRC_DIR)/gl_texture.o \
    $(SRC_DIR)/gl_texture_functions.o \
    $(SRC_DIR)/vid_common_gl.o

COMMON_RENDERER_OBJS := \
    $(SRC_DIR)/r_aliasmodel.o \
    $(SRC_DIR)/r_aliasmodel_md3.o \
    $(SRC_DIR)/r_aliasmodel_mesh.o \
    $(SRC_DIR)/r_aliasmodel_skins.o \
    $(SRC_DIR)/r_atlas.o \
    $(SRC_DIR)/r_bloom.o \
    $(SRC_DIR)/r_brushmodel.o \
    $(SRC_DIR)/r_brushmodel_bspx.o \
    $(SRC_DIR)/r_brushmodel_load.o \
    $(SRC_DIR)/r_brushmodel_sky.o \
    $(SRC_DIR)/r_brushmodel_surfaces.o \
    $(SRC_DIR)/r_brushmodel_textures.o \
    $(SRC_DIR)/r_brushmodel_warpsurfaces.o \
    $(SRC_DIR)/r_buffers.o \
    $(SRC_DIR)/r_chaticons.o \
    $(SRC_DIR)/r_draw.o \
    $(SRC_DIR)/r_draw_charset.o \
    $(SRC_DIR)/r_draw_circle.o \
    $(SRC_DIR)/r_draw_image.o \
    $(SRC_DIR)/r_draw_line.o \
    $(SRC_DIR)/r_draw_polygon.o \
    $(SRC_DIR)/r_hud.o \
    $(SRC_DIR)/r_lightmaps.o \
    $(SRC_DIR)/r_main.o \
    $(SRC_DIR)/r_matrix.o \
    $(SRC_DIR)/r_misc.o \
    $(SRC_DIR)/r_model.o \
    $(SRC_DIR)/r_netgraph.o \
    $(SRC_DIR)/r_palette.o \
    $(SRC_DIR)/r_part.o \
    $(SRC_DIR)/r_part_trails.o \
    $(SRC_DIR)/r_particles_qmb.o \
    $(SRC_DIR)/r_particles_qmb_trails.o \
    $(SRC_DIR)/r_particles_qmb_spawn.o \
    $(SRC_DIR)/r_performance.o \
    $(SRC_DIR)/r_refrag.o \
    $(SRC_DIR)/r_rlight.o \
    $(SRC_DIR)/r_rmain.o \
    $(SRC_DIR)/r_rmisc.o \
    $(SRC_DIR)/r_sprite3d.o \
    $(SRC_DIR)/r_sprites.o \
    $(SRC_DIR)/r_states.o \
    $(SRC_DIR)/r_texture.o \
    $(SRC_DIR)/r_texture_cvars.o \
    $(SRC_DIR)/r_texture_load.o \
    $(SRC_DIR)/r_texture_util.o \
    $(SRC_DIR)/vx_camera.o \
    $(SRC_DIR)/vx_coronas.o \
    $(SRC_DIR)/vx_stuff.o \
    $(SRC_DIR)/vx_vertexlights.o

HUD_OBJS := \
    $(SRC_DIR)/hud.o \
    $(SRC_DIR)/hud_262.o \
    $(SRC_DIR)/hud_common.o \
    $(SRC_DIR)/hud_editor.o \
    $(SRC_DIR)/hud_radar.o \
    $(SRC_DIR)/hud_speed.o \
    $(SRC_DIR)/hud_teaminfo.o \
    $(SRC_DIR)/hud_weapon_stats.o \
    $(SRC_DIR)/hud_autoid.o \
    $(SRC_DIR)/hud_clock.o \
    $(SRC_DIR)/hud_ammo.o \
    $(SRC_DIR)/hud_items.o \
    $(SRC_DIR)/hud_net.o \
    $(SRC_DIR)/hud_guns.o \
    $(SRC_DIR)/hud_groups.o \
    $(SRC_DIR)/hud_armor.o \
    $(SRC_DIR)/hud_health.o \
    $(SRC_DIR)/hud_gamesummary.o \
    $(SRC_DIR)/hud_face.o \
    $(SRC_DIR)/hud_frags.o \
    $(SRC_DIR)/hud_tracking.o \
    $(SRC_DIR)/hud_scores.o \
    $(SRC_DIR)/hud_performance.o \
    $(SRC_DIR)/hud_centerprint.o \
    $(SRC_DIR)/hud_qtv.o

OBJS_c := \
    $(COMMON_OBJS) \
    $(HELP_OBJS) \
    $(HUD_OBJS) \
    $(COMMON_RENDERER_OBJS) \
    $(SRC_DIR)/Ctrl.o \
    $(SRC_DIR)/Ctrl_EditBox.o \
    $(SRC_DIR)/Ctrl_PageViewer.o \
    $(SRC_DIR)/Ctrl_ScrollBar.o \
    $(SRC_DIR)/Ctrl_Tab.o \
    $(SRC_DIR)/EX_FileList.o \
    $(SRC_DIR)/EX_browser.o \
    $(SRC_DIR)/EX_browser_net.o \
    $(SRC_DIR)/EX_browser_pathfind.o \
    $(SRC_DIR)/EX_browser_ping.o \
    $(SRC_DIR)/EX_browser_qtvlist.o \
    $(SRC_DIR)/EX_browser_sources.o \
    $(SRC_DIR)/EX_qtvlist.o \
    $(SRC_DIR)/ez_controls.o \
    $(SRC_DIR)/ez_scrollbar.o \
    $(SRC_DIR)/ez_scrollpane.o \
    $(SRC_DIR)/ez_label.o \
    $(SRC_DIR)/ez_slider.o \
    $(SRC_DIR)/ez_button.o \
    $(SRC_DIR)/ez_window.o \
    $(SRC_DIR)/cl_cam.o \
    $(SRC_DIR)/cl_cmd.o \
    $(SRC_DIR)/cl_demo.o \

=== debian/changelog ===
ezquake (3.6.4-3build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:47:23 +1100

ezquake (3.6.4-3build3) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:52:17 +0000

ezquake (3.6.4-3build2) noble; urgency=medium

  * No-change rebuild against libminizip1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 03:30:11 +0000

ezquake (3.6.4-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:27:35 +0000

ezquake (3.6.4-3) unstable; urgency=medium

  * Fix 32-bit pointer conversion warning.

 -- Michael Gilbert <mgilbert@debian.org>  Mon, 15 Jan 2024 04:26:53 +0000

ezquake (3.6.4-2) unstable; urgency=medium

  * Add a manpage.
  * Fix incorrect format string.
  * Fix pointer conversion warnings.
  * Translate keymap files to UTF-8.
  * Drop patches that are no longer relevant.
  * Include debian revision in the version string.

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 14 Jan 2024 21:06:31 +0000

ezquake (3.6.4-1) unstable; urgency=medium

  * Team upload
  * Import project on Salsa
  * remove dependency on obsolete pcre3 library (Closes: #1000035)
  * catchup with new build system: meson has been
    replaced with a static Makefile
  * refresh patches

  [Bastian Germann]
  * Add new copyright

 -- Alexandre Detiste <tchet@debian.org>  Wed, 20 Dec 2023 02:51:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: ezquake
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- meson,
- ninja-build,
  zlib1g-dev,
  libpng-dev,
  libsdl2-dev,
  libjpeg-dev,
  liblzma-dev,
- libpcre3-dev,
+ libpcre2-dev,
  libexpat-dev,
  libspeex-dev,
  libvorbis-dev,
@@ -23,7 +22,9 @@
  libcurl4-gnutls-dev,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://ezquake.com
+Homepage: https://ezquake.com
+Vcs-Git: https://salsa.debian.org/games-team/ezquake.git
+Vcs-Browser: https://salsa.debian.org/games-team/ezquake
 
 Package: ezquake
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export V=1

export DEB_BUILD_DATE="$(shell dpkg-parsechangelog --show-field=date)"

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS) -Wno-deprecated-declarations -Wno-misleading-indentation -Wno-format-truncation -Wno-unused-result -Wno-unused-function -Werror -DBUILD_DATE=\"$(DEB_BUILD_DATE)\"

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install-arch:
	cp ezquake-* ezquake
	dh_install
	./debian/scripts/convert-keymaps

override_dh_clean:
	rm -rf opengl minizip vstudio-libs mingw32-libs misc/vstudio misc/install
	dh_clean

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ezquake-$1\.tar\.gz/ \
  https://github.com/ezQuake/ezquake-source/tags .*/v?(\d\S+)\.tar\.gz

## ezquake 3.6.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

project(ezquake C)

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    enable_language(OBJC)
endif()

option(USE_SYSTEM_LIBS          "Use system libraries instead of VCPKG"       ON)
option(RENDERER_MODERN_OPENGL   "Enable modern OpenGL renderer"               ON)
option(RENDERER_CLASSIC_OPENGL  "Enable classic OpenGL renderer"              ON)
option(DEBUG_MEMORY_ALLOCATIONS "Enable debug prints for memory allocations" OFF)
option(ENABLE_SANDBOX           "Enables application sandboxing (macOS)"      ON)
option(ENABLE_LTO               "Enable Link Time Optimization"               ON)

if(NOT RENDERER_CLASSIC_OPENGL AND NOT RENDERER_MODERN_OPENGL)
    message(FATAL_ERROR "At least one of RENDERER_CLASSIC_OPENGL or RENDERER_MODERN_OPENGL must be enabled.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(GitUtils)
include(AddResources)
include(CheckIPOSupported)
include(CheckCCompilerFlag)
include(CheckDependency)

git_refresh_submodules()
git_extract_version(git_version)

# Xcode has its own LTO features.
if(ENABLE_LTO AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    check_ipo_supported(RESULT USE_LTO)
    if(USE_LTO)
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO TRUE)
    else()
        message(FATAL_ERROR "Link Time Optimization requested, but not available.")
    endif()
endif()

if(ENABLE_LTO)
    message("-- Link Time Optimization: Enabled")
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
    add_compile_options(
            /nologo
            /W3
            /WX-
            /diagnostics:column
    )

    set(CMAKE_MSVC_RUNTIME_LIBRARY MultiThreaded$<$<CONFIG:Debug>:Debug>)
    set(CMAKE_MSVC_DEBUG_INFORMATION_FORMAT $<$<CONFIG:Debug>:ProgramDatabase>)

    # Enable automatic parallelization of MSBuild
    set(CMAKE_VS_GLOBALS
            "UseMultiToolTask=true"
            "EnforceProcessCountAcrossBuilds=true"
    )

    if(EXISTS "${PROJECT_SOURCE_DIR}/ezquake.vcxproj.user")
        configure_file("${PROJECT_SOURCE_DIR}/ezquake.vcxproj.user" "${CMAKE_BINARY_DIR}/ezquake.vcxproj.user" COPYONLY)
    endif()
else()
    add_compile_options(
            -std=gnu89

            -Wall
            -Wno-pointer-to-int-cast
            -Wno-int-to-pointer-cast
            -Wno-strict-aliasing
            -Wno-deprecated-declarations

            -fvisibility=hidden

            -Werror=format
            -Werror=strict-prototypes
            -Werror=old-style-definition

            $<$<CONFIG:Release>:-Werror=unused-function>
            $<$<CONFIG:Release>:-Werror=unused-variable>
    )

    check_c_compiler_flag("-Wstrlcpy-strlcat-size" HAS_STRLCPY_STRLCAT_SIZE)
    if(HAS_STRLCPY_STRLCAT_SIZE)
        add_compile_options("-Werror=strlcpy-strlcat-size")
    endif()
    check_c_compiler_flag("-Wformat-truncation" HAS_FORMAT_TRUNCATION)
    if(HAS_FORMAT_TRUNCATION)
        add_compile_options("-Wno-error=format-truncation" "-Wno-format-truncation")
    endif()
    check_c_compiler_flag("-Wparentheses" HAS_PARENTHESIS)
    if(HAS_PARENTHESIS)
        add_compile_options("-Wno-parentheses")
    endif()
    check_c_compiler_flag("-Wmisleading-indentation" HAS_MISLEADING_INDENTATION)
    if(HAS_MISLEADING_INDENTATION)
        add_compile_options("-Wno-misleading-indentation")
    endif()
    # While not gnu89, it's in practice allowed by all supported compilers
    check_c_compiler_flag("-Wtypedef-redefinition" HAS_TYPE_REDEFINITION)
    if(HAS_TYPE_REDEFINITION)
        add_compile_options("-Wno-typedef-redefinition")
    endif()
    # Should mostly be fixed in mvdsv, and next sync can remove this
    check_c_compiler_flag("-Wshorten-64-to-32" HAS_SHORTEN_64_TO_32)
    if(HAS_TYPE_REDEFINITION)
        add_compile_options("-Wno-shorten-64-to-32")
    endif()
endif()

find_library(MATH m)

# Override by configuring with -DOpenGL_GL_PREFERENCE=GLVND
if(NOT OpenGL_GL_PREFERENCE)
    set(OpenGL_GL_PREFERENCE LEGACY)
endif()
find_package(OpenGL REQUIRED)
find_package(Threads REQUIRED)

# Args: target name, pkg-config name, vcpkg package name, vcpkg target name, extra args
check_dependency(Expat    "expat"      "EXPAT"              "expat::expat"                 REQUIRED CONFIG)
check_dependency(FreeType "freetype2"  "Freetype"           "Freetype::Freetype"           OPTIONAL)
check_dependency(JPEG     "libjpeg"    "JPEG"               "JPEG::JPEG"                   REQUIRED)
check_dependency(Jansson  "jansson"    "jansson"            "jansson::jansson"             REQUIRED)
check_dependency(MiniZip  "minizip"    "unofficial-minizip" "unofficial::minizip::minizip" REQUIRED)
check_dependency(PCRE2    "libpcre2-8" "PCRE2"              "pcre2::pcre2-8-static"        REQUIRED)
check_dependency(PNG      "libpng"     "PNG"                "PNG::PNG"                     REQUIRED)
check_dependency(SDL2     "sdl2"       "SDL2"               "SDL2::SDL2-static"            REQUIRED)
check_dependency(SndFile  "sndfile"    "SndFile"            "SndFile::sndfile"             REQUIRED)
check_dependency(Speex    "speex"      "Speex"              "SPEEX::SPEEX"                 OPTIONAL)
check_dependency(SpeexDSP "speexdsp"   "SpeexDSP"           "SPEEX::SPEEXDSP"              OPTIONAL)
check_dependency(cURL     "libcurl"    "CURL"               "CURL::libcurl"                REQUIRED CONFIG)
check_dependency(zlib     "zlib"       "ZLIB"               "ZLIB::ZLIB"                   REQUIRED)

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    find_library(FRAMEWORK_APPKIT AppKit REQUIRED)
    find_library(FRAMEWORK_FOUNDATION Foundation REQUIRED)
    find_library(FRAMEWORK_CORESERVICES CoreServices REQUIRED)
    find_library(FRAMEWORK_GAMECONTROLLER GameController REQUIRED)
endif()

# Place special CMake targets in separate VS/Xcode folder
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY VS_STARTUP_PROJECT "ezquake")

set(SOURCE_DIR ${PROJECT_SOURCE_DIR}/src)

set(common_headers
        ${SOURCE_DIR}/bspfile.h
        ${SOURCE_DIR}/cmd.h
        ${SOURCE_DIR}/cmdline_params.h
        ${SOURCE_DIR}/cmdline_params_ids.h
        ${SOURCE_DIR}/cmodel.h
        ${SOURCE_DIR}/common.h
        ${SOURCE_DIR}/crc.h
        ${SOURCE_DIR}/cvar.h
        ${SOURCE_DIR}/cvar_groups.h
        ${SOURCE_DIR}/fs.h
        ${SOURCE_DIR}/hash.h
        ${SOURCE_DIR}/macro_definitions.h
        ${SOURCE_DIR}/macro_ids.h
        ${SOURCE_DIR}/mathlib.h
        ${SOURCE_DIR}/net.h
        ${SOURCE_DIR}/parser.h
        ${SOURCE_DIR}/pmove.h
        ${SOURCE_DIR}/q_platform.h
        ${SOURCE_DIR}/q_shared.h
        ${SOURCE_DIR}/sha1.h
        ${SOURCE_DIR}/sha3.h
        ${SOURCE_DIR}/version.h
        ${SOURCE_DIR}/vfs.h
        ${SOURCE_DIR}/vfs_tar.h
        ${SOURCE_DIR}/zone.h
)
set(common
        ${SOURCE_DIR}/cmd.c
        ${SOURCE_DIR}/cmodel.c
        ${SOURCE_DIR}/com_msg.c
        ${SOURCE_DIR}/common.c
        ${SOURCE_DIR}/crc.c
        ${SOURCE_DIR}/cvar.c
        ${SOURCE_DIR}/fs.c
        ${SOURCE_DIR}/hash.c
        ${SOURCE_DIR}/mathlib.c
        ${SOURCE_DIR}/md4.c
        ${SOURCE_DIR}/net.c
        ${SOURCE_DIR}/net_chan.c
        ${SOURCE_DIR}/parser.c
        ${SOURCE_DIR}/pmove.c
        ${SOURCE_DIR}/pmovetst.c
        ${SOURCE_DIR}/q_shared.c
        ${SOURCE_DIR}/sha1.c
        ${SOURCE_DIR}/sha3.c
        ${SOURCE_DIR}/version.c
        ${SOURCE_DIR}/vfs_doomwad.c
        ${SOURCE_DIR}/vfs_gzip.c
        ${SOURCE_DIR}/vfs_mmap.c
        ${SOURCE_DIR}/vfs_os.c
        ${SOURCE_DIR}/vfs_pak.c
        ${SOURCE_DIR}/vfs_tar.c
        ${SOURCE_DIR}/vfs_tcp.c
        ${SOURCE_DIR}/vfs_zip.c
        ${SOURCE_DIR}/zone.c
        ${common_headers}
)
source_group(TREE ${SOURCE_DIR} PREFIX "Source Files/common" FILES ${common})
source_group(TREE ${SOURCE_DIR} PREFIX "Header Files/common" FILES ${common_headers})

set(QWPROT_SOURCE_DIR ${SOURCE_DIR}/qwprot/src)
set(qwprot_headers
        ${QWPROT_SOURCE_DIR}/protocol.h
)
source_group(TREE ${QWPROT_SOURCE_DIR} PREFIX "Header Files/qwprot" FILES ${qwprot_headers})

set(server_headers
        ${SOURCE_DIR}/g_public.h
        ${SOURCE_DIR}/pr2.h
        ${SOURCE_DIR}/pr_comp.h
        ${SOURCE_DIR}/progdefs.h
        ${SOURCE_DIR}/progs.h
        ${SOURCE_DIR}/qwsvdef.h
        ${SOURCE_DIR}/server.h
        ${SOURCE_DIR}/sv_log.h
        ${SOURCE_DIR}/sv_mod_frags.h
        ${SOURCE_DIR}/sv_world.h
        ${SOURCE_DIR}/vm.h
        ${SOURCE_DIR}/vm_local.h
)
set(server
        ${SOURCE_DIR}/pr2_cmds.c
        ${SOURCE_DIR}/pr2_edict.c
        ${SOURCE_DIR}/pr2_exec.c
        ${SOURCE_DIR}/pr_cmds.c
        ${SOURCE_DIR}/pr_edict.c
        ${SOURCE_DIR}/pr_exec.c
        ${SOURCE_DIR}/sv_ccmds.c
        ${SOURCE_DIR}/sv_demo.c
        ${SOURCE_DIR}/sv_demo_misc.c
        ${SOURCE_DIR}/sv_demo_qtv.c
        ${SOURCE_DIR}/sv_ents.c
        ${SOURCE_DIR}/sv_init.c
        ${SOURCE_DIR}/sv_login.c
        ${SOURCE_DIR}/sv_main.c
        ${SOURCE_DIR}/sv_master.c
        ${SOURCE_DIR}/sv_mod_frags.c
        ${SOURCE_DIR}/sv_move.c
        ${SOURCE_DIR}/sv_nchan.c
        ${SOURCE_DIR}/sv_phys.c
        ${SOURCE_DIR}/sv_save.c
        ${SOURCE_DIR}/sv_send.c
        ${SOURCE_DIR}/sv_user.c
        ${SOURCE_DIR}/sv_world.c
        ${SOURCE_DIR}/vm.c
        ${SOURCE_DIR}/vm_interpreted.c
        ${SOURCE_DIR}/vm_x86.c
        ${server_headers}
)
source_group(TREE ${SOURCE_DIR} PREFIX "Source Files/server" FILES ${server})
source_group(TREE ${SOURCE_DIR} PREFIX "Header Files/server" FILES ${server_headers})

if(RENDERER_MODERN_OPENGL OR RENDERER_CLASSIC_OPENGL)
    set(SHARED_GLSL_DIR ${SOURCE_DIR}/glsl/shared)
    add_resources(shaders_shared
            ${SHARED_GLSL_DIR}/fxaa.h.glsl
    )
    source_group(TREE ${SOURCE_DIR} PREFIX "Source Files/shared_opengl" FILES ${shared_opengl})
    source_group(TREE ${SOURCE_DIR} PREFIX "Header Files/shared_opengl" FILES ${shared_opengl_headers})
endif()

if(RENDERER_MODERN_OPENGL)
    set(MODERN_GLSL_DIR ${SOURCE_DIR}/glsl)
    add_resources(shaders_modern
            ${MODERN_GLSL_DIR}/common.glsl
            ${MODERN_GLSL_DIR}/constants.glsl
            ${MODERN_GLSL_DIR}/draw_aliasmodel.fragment.glsl
            ${MODERN_GLSL_DIR}/draw_aliasmodel.vertex.glsl
            ${MODERN_GLSL_DIR}/draw_sprites.fragment.glsl
            ${MODERN_GLSL_DIR}/draw_sprites.vertex.glsl
            ${MODERN_GLSL_DIR}/draw_world.fragment.glsl
            ${MODERN_GLSL_DIR}/draw_world.vertex.glsl
            ${MODERN_GLSL_DIR}/fx_world_geometry.fragment.glsl
            ${MODERN_GLSL_DIR}/fx_world_geometry.vertex.glsl
            ${MODERN_GLSL_DIR}/hud_draw_circle.fragment.glsl
            ${MODERN_GLSL_DIR}/hud_draw_circle.vertex.glsl
            ${MODERN_GLSL_DIR}/hud_draw_image.fragment.glsl
            ${MODERN_GLSL_DIR}/hud_draw_image.geometry.glsl
            ${MODERN_GLSL_DIR}/hud_draw_image.vertex.glsl
            ${MODERN_GLSL_DIR}/hud_draw_line.fragment.glsl
            ${MODERN_GLSL_DIR}/hud_draw_line.vertex.glsl
            ${MODERN_GLSL_DIR}/hud_draw_polygon.fragment.glsl
            ${MODERN_GLSL_DIR}/hud_draw_polygon.vertex.glsl
            ${MODERN_GLSL_DIR}/lighting.compute.glsl
            ${MODERN_GLSL_DIR}/post_process_screen.fragment.glsl
            ${MODERN_GLSL_DIR}/post_process_screen.vertex.glsl
            ${MODERN_GLSL_DIR}/simple.fragment.glsl
            ${MODERN_GLSL_DIR}/simple.vertex.glsl
            ${MODERN_GLSL_DIR}/simple3d.fragment.glsl
            ${MODERN_GLSL_DIR}/simple3d.vertex.glsl
    )

    set(modern_opengl_headers
            ${SOURCE_DIR}/glm_brushmodel.h
            ${SOURCE_DIR}/glm_draw.h
            ${SOURCE_DIR}/glm_local.h
            ${SOURCE_DIR}/glm_particles.h
            ${SOURCE_DIR}/glm_texture_arrays.h
            ${SOURCE_DIR}/glm_vao.h
    )
    set(modern_opengl
            ${SOURCE_DIR}/glm_aliasmodel.c
            ${SOURCE_DIR}/glm_brushmodel.c
            ${SOURCE_DIR}/glm_draw.c

=== debian/changelog ===
ezquake (3.6.6-1) unstable; urgency=medium

  * Update d/watch file
  * New upstream version 3.6.6 (Closes: #1089179, #1079531)
  * Bump SV to 4.7.2
  * Update BD
  * Improve d/scripts/ezquake
  * Remove scripts/convert-keymaps and install
  * Refresh d/patches
  * Remove for now -Werror in d/rules
  * Add d/patches/pcre2.patch (Closes: #1088891)
  * d/copyright: remove misc/keymaps/* statement
  * Clean up d/rules
  * d/rules: binary as moved.
  * d/control: remove quake-data dep and reformat (depputy).
  * Add a README.Debian.

 -- Patrice Duroux <patrice.duroux@gmail.com>  Sat, 05 Apr 2025 12:40:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,30 +1,32 @@
 Source: ezquake
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Michael Gilbert <mgilbert@debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders:
+ Michael Gilbert <mgilbert@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- zlib1g-dev,
+ cmake,
+ libcurl4-gnutls-dev,
+ libexpat-dev,
+ libfreetype-dev,
+ libjansson-dev,
+ libjpeg-dev,
+ libminizip-dev,
+ libpcre2-dev,
  libpng-dev,
  libsdl2-dev,
- libjpeg-dev,
- liblzma-dev,
- libpcre2-dev,
- libexpat-dev,
+ libsndfile1-dev,
  libspeex-dev,
- libvorbis-dev,
- libjansson-dev,
- libminizip-dev,
- libsndfile1-dev,
  libspeexdsp-dev,
- libcurl4-gnutls-dev,
-Standards-Version: 4.6.2
+ pkgconf,
+ zlib1g-dev,
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://ezquake.com
 Vcs-Git: https://salsa.debian.org/games-team/ezquake.git
 Vcs-Browser: https://salsa.debian.org/games-team/ezquake
+X-Style: black
 
 Package: ezquake
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_DATE="$(shell dpkg-parsechangelog --show-field=date)"

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS) -Wno-deprecated-declarations -Wno-misleading-indentation -Wno-format-truncation -Wno-unused-result -Wno-unused-function -DBUILD_DATE=\"$(DEB_BUILD_DATE)\"

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_install:
	mv obj-*/ezquake-* ezquake
	rm -rf obj-*
	dh_auto_install

=== debian/watch ===
version=4
opts="downloadurlmangle=s/archive\/refs\/tags\/@ANY_VERSION@(@ARCHIVE_EXT@)/releases\/download\/$1\/ezquake-source-$1$2/" \
 https://github.com/QW-Group/ezquake-source/tags .*/@ANY_VERSION@@ARCHIVE_EXT@

## ezquake 3.6.8

=== debian/changelog ===
ezquake (3.6.8-1) unstable; urgency=medium

  * d/watch: version 5
  * d/gbp.conf: added with pristine.
  * New upstream version 3.6.8
  * d/salsa-ci.yml: added
  * d/control: remove RRR: no (default)

 -- Patrice Duroux <patrice.duroux@gmail.com>  Mon, 29 Dec 2025 09:02:13 +0100

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Michael Gilbert <mgilbert@debian.org>,
+ Patrice Duroux <patrice.duroux@gmail.com>,
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -22,7 +23,6 @@
  pkgconf,
  zlib1g-dev,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://ezquake.com
 Vcs-Git: https://salsa.debian.org/games-team/ezquake.git
 Vcs-Browser: https://salsa.debian.org/games-team/ezquake

=== debian/watch ===
Version: 5

Source: https://github.com/QW-Group/ezquake-source/tags
Matching-Pattern: .*/@ANY_VERSION@@ARCHIVE_EXT@
Download-Url-Mangle: s/archive\/refs\/tags\/@ANY_VERSION@(@ARCHIVE_EXT@)/releases\/download\/$1\/ezquake-source-$1$2/
